ShieldOn = LibStub("AceAddon-3.0"):NewAddon("ShieldOn", "AceConsole-3.0", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("ShieldOn")

local options = {
    name = "ShieldOn",
    handler = ShieldOn,
    type = "group",
    args = {
        instructions = {
            order = 1,
            type = "description",
            name = L["To input items: Click on a box and Shift-Click an item or Drag and drop items into boxes"],
            cmdHidden = true,
        },
        update = {
            type = "execute",
            name = L["Update Equipment Sets"],
            desc = L["Forces an update of the equipment sets"],
            func = function() ShieldOn:UpdateButton() end,
        },
        enablePvESets = {
            type = "toggle",
            name = L["PvE Sets"],
            desc = L["Toggles the updating of sets for PvE."],
            get = function(info) return ShieldOn.db.profile.PvEEnabled end,
            set = function(info, v) ShieldOn.db.profile.PvEEnabled = v end,
        },
        enablePvPSets = {
            type = "toggle",
            name = L["PvP Sets"],
            desc = L["Toggles the updating of sets for PvP."],
            get = function(info) return ShieldOn.db.profile.PvPEnabled end,
            set = function(info, v) ShieldOn.db.profile.PvPEnabled = v end,
        },
        armsPvEGroup = {
            type = "group",
            name = L["Arms PvE"],
            args = {
                armsPvE2H = {
                    type = "input",
                    name = L["2-Handed Weapon for Arms PvE"],
                    desc = L["Stores the name of your 2-Handed weapon for Arms when doing PvE"],
                    usage = L["<Name of Weapon>"],
                    get = function(info) return ShieldOn.db.profile.Arms2H["PvE"] end,
                    set = function(info, v) ShieldOn.db.profile.Arms2H["PvE"] = v end,
                    width = "double",
                    order = 1,
                },
                armsPvE1H = {
                    type = "input",
                    name = L["1-Handed Weapon for Arms PvE"],
                    desc = L["Stores the name of your 1-Handed weapon for Arms when doing PvE"],
                    usage = L["<Name of Weapon>"],
                    get = function(info) return ShieldOn.db.profile.Arms1H["PvE"] end,
                    set = function(info, v) ShieldOn.db.profile.Arms1H["PvE"] = v end,
                    width = "double",
                    order = 2,
                },
                armsPvEShield = {
                    type = "input",
                    name = L["Shield for Arms PvE"],
                    desc = L["Stores the name of your Shield for Arms when doing PvE"],
                    usage = L["<Name of Shield>"],
                    get = function(info) return ShieldOn.db.profile.ArmsShield["PvE"] end,
                    set = function(info, v) ShieldOn.db.profile.ArmsShield["PvE"] = v end,
                    width = "double",
                    order = 3,
                },
            },
        },
        armsPvPGroup = {
            type = "group",
            name = L["Arms PvP"],
            args = {
                armsPvP2H = {
                    type = "input",
                    name = L["2-Handed Weapon for Arms PvP"],
                    desc = L["Stores the name of your 2-Handed weapon for Arms when doing PvP"],
                    usage = L["<Name of Weapon>"],
                    get = function(info) return ShieldOn.db.profile.Arms2H["PvP"] end,
                    set = function(info, v) ShieldOn.db.profile.Arms2H["PvP"] = v end,
                    width = "double",
                    order = 1,
                },
                armsPvP1H = {
                    type = "input",
                    name = L["1-Handed Weapon for Arms PvP"],
                    desc = L["Stores the name of your 1-Handed weapon for Arms when doing PvP"],
                    usage = L["<Name of Weapon>"],
                    get = function(info) return ShieldOn.db.profile.Arms1H["PvP"] end,
                    set = function(info, v) ShieldOn.db.profile.Arms1H["PvP"] = v end,
                    width = "double",
                    order = 2,
                },
                armsPvPShield = {
                    type = "input",
                    name = L["Shield for Arms PvP"],
                    desc = L["Stores the name of your Shield for Arms when doing PvP"],
                    usage = L["<Name of Shield>"],
                    get = function(info) return ShieldOn.db.profile.ArmsShield["PvP"] end,
                    set = function(info, v) ShieldOn.db.profile.ArmsShield["PvP"] = v end,
                    width = "double",
                    order = 3,
                },
            },
        },
        furyPvEGroup = {
            type = "group",
            name = L["Fury PvE"],
            args = {
                furyPvEMH = {
                    type = "input",
                    name = L["Mainhand Weapon for Fury PvE"],
                    desc = L["Stores the name of your Mainhand weapon for Fury when doing PvE"],
                    usage = L["<Name of Weapon>"],
                    get = function(info) return ShieldOn.db.profile.FuryMH["PvE"] end,
                    set = function(info, v) ShieldOn.db.profile.FuryMH["PvE"] = v end,
                    width = "double",
                    order = 1,
                },
                furyPvEOH = {
                    type = "input",
                    name = L["Offhand Weapon for Fury PvE"],
                    desc = L["Stores the name of your Offhand weapon for Fury when doing PvE"],
                    usage = L["<Name of Weapon>"],
                    get = function(info) return ShieldOn.db.profile.FuryOH["PvE"] end,
                    set = function(info, v) ShieldOn.db.profile.FuryOH["PvE"] = v end,
                    width = "double",
                    order = 2,
                },
                furyPvEShield = {
                    type = "input",
                    name = L["Shield for Fury PvE"],
                    desc = L["Stores the name of your Shield for Fury when doing PvE"],
                    usage = L["<Name of Shield>"],
                    get = function(info) return ShieldOn.db.profile.FuryShield["PvE"] end,
                    set = function(info, v) ShieldOn.db.profile.FuryShield["PvE"] = v end,
                    width = "double",
                    order = 3,
                },
            },
        },
        furyPvPGroup = {
            type = "group",
            name = L["Fury PvP"],
            args = {
                furyPvPMH = {
                    type = "input",
                    name = L["Mainhand Weapon for Fury PvP"],
                    desc = L["Stores the name of your Mainhand weapon for Fury when doing PvP"],
                    usage = L["<Name of Weapon>"],
                    get = function(info) return ShieldOn.db.profile.FuryMH["PvP"] end,
                    set = function(info, v) ShieldOn.db.profile.FuryMH["PvP"] = v end,
                    width = "double",
                    order = 1,
                },
                furyPvPOH = {
                    type = "input",
                    name = L["Offhand Weapon for Fury PvP"],
                    desc = L["Stores the name of your Offhand weapon for Fury when doing PvP"],
                    usage = L["<Name of Weapon>"],
                    get = function(info) return ShieldOn.db.profile.FuryOH["PvP"] end,
                    set = function(info, v) ShieldOn.db.profile.FuryOH["PvP"] = v end,
                    width = "double",
                    order = 2,
                },
                furyPvPShield = {
                    type = "input",
                    name = L["Shield for Fury PvP"],
                    desc = L["Stores the name of your Shield for Fury when doing PvP"],
                    usage = L["<Name of Shield>"],
                    get = function(info) return ShieldOn.db.profile.FuryShield["PvP"] end,
                    set = function(info, v) ShieldOn.db.profile.FuryShield["PvP"] = v end,
                    width = "double",
                    order = 3,
                },
            },
        },
        protPvEGroup = {
            type = "group",
            name = L["Protection PvE"],
            args = {
                protPvE1H = {
                    type = "input",
                    name = L["1-Handed Weapon for Protection PvE"],
                    desc = L["Stores the name of your 1-Handed weapon for Protection when doing PvE"],
                    usage = L["<Name of Weapon>"],
                    get = function(info) return ShieldOn.db.profile.Prot1H["PvE"] end,
                    set = function(info, v) ShieldOn.db.profile.Prot1H["PvE"] = v end,
                    width = "double",
                    order = 1,
                },
                protPvEShield = {
                    type = "input",
                    name = L["Shield for Protection PvE"],
                    desc = L["Stores the name of your Shield for Protection when doing PvE"],
                    usage = L["<Name of Shield>"],
                    get = function(info) return ShieldOn.db.profile.ProtShield["PvE"] end,
                    set = function(info, v) ShieldOn.db.profile.ProtShield["PvE"] = v end,
                    width = "double",
                    order = 2,
                },
            },
        },
        protPvPGroup = {
            type = "group",
            name = L["Protection PvP"],
            args = {
                protPvP1H = {
                    type = "input",
                    name = L["1-Handed Weapon for Protection PvP"],
                    desc = L["Stores the name of your 1-Handed weapon for Protection when doing PvP"],
                    usage = L["<Name of Weapon>"],
                    get = function(info) return ShieldOn.db.profile.Prot1H["PvP"] end,
                    set = function(info, v) ShieldOn.db.profile.Prot1H["PvP"] = v end,
                    width = "double",
                    order = 1,
                },
                protPvPShield = {
                    type = "input",
                    name = L["Shield for Protection PvP"],
                    desc = L["Stores the name of your Shield for Protection when doing PvP"],
                    usage = L["<Name of Shield>"],
                    get = function(info) return ShieldOn.db.profile.ProtShield["PvP"] end,
                    set = function(info, v) ShieldOn.db.profile.ProtShield["PvP"] = v end,
                    width = "double",
                    order = 2,
                },
            },
        },
    },
}

local defaults = {
    profile = {
        PvEEnabled = true,
        PvPEnabled = false,
        Arms2H = {
            ["PvE"] = "",
            ["PvP"] = "",
        },
        Arms1H = {
            ["PvE"] = "",
            ["PvP"] = "",
        },
        ArmsShield = {
            ["PvE"] = "",
            ["PvP"] = "",
        },
        FuryMH = {
            ["PvE"] = "",
            ["PvP"] = "",
        },
        FuryOH = {
            ["PvE"] = "",
            ["PvP"] = "",
        },
        FuryShield = {
            ["PvE"] = "",
            ["PvP"] = "",
        },
        Prot1H = {
            ["PvE"] = "",
            ["PvP"] = "",
        },
        ProtShield = {
            ["PvE"] = "",
            ["PvP"] = "",
        },
    },
}

function ShieldOn:OnInitialize()
    --Called when the addon is loaded
    self.db = LibStub("AceDB-3.0"):New("ShieldOnDB", defaults)
    LibStub("AceConfig-3.0"):RegisterOptionsTable("ShieldOn", options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("ShieldOn", "ShieldOn")
    self:RegisterChatCommand(L["ShieldOn"], "ChatCommand")
    self:RegisterChatCommand(L["so"], "ChatCommand")
end

function ShieldOn:OnEnable()
    --Called when the addon is enabled
    self:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
end

function ShieldOn:OnDisable()
    --Called when the addon is disabled
end

function ShieldOn:ChatCommand(input)
    --Sets up chat commands for addon
    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
    else
        LibStub("AceConfigCmd-3.0").HandleCommand(ShieldOn, L["so"], L["ShieldOn"], input)
    end
end

function ShieldOn:CheckSpec()
    --Get the name of active spec and store it
    local currentSpec = GetSpecialization()
    if currentSpec then
    	self.db.profile.Spec = select(2, GetSpecializationInfo(currentSpec))
    end
end

function ShieldOn:PLAYER_SPECIALIZATION_CHANGED()
    if self.db.profile.PvEEnabled or self.db.profile.PvPEnabled then
        --Do an update if spec is different
        local oldSpec = self.db.profile.Spec
        self:CheckSpec()
        if oldSpec ~= self.db.profile.Spec then
            self:Update()
        end
    end
end

function ShieldOn:UpdateButton()
    --Called when update button is used
    if self.db.profile.PvEEnabled or self.db.profile.PvPEnabled then
        self:CheckSpec()
        self:Update()
    end
end

function ShieldOn:Update()
    --CreateShieldSet leads onto CreateNormalSet
    --If PvE fine run PvE
    --If only PvP fine run PvP
    --When both fine saving of PvP will occur via last confirmation box of PvE
    if self.db.profile.PvEEnabled and self:CheckSet("PvE")then
		self:CreateShieldSet("PvE")
    else
    	if self.db.profile.PvPEnabled and self:CheckSet("PvP") then
        	self:CreateShieldSet("PvP")
        end
    end
end

function ShieldOn:CheckSet(setType)
    --Return true if all equipment has been setup for spec and set type
    if self.db.profile.Spec == "Protection" then
        if self.db.profile.Prot1H[setType] ~= "" and self.db.profile.ProtShield[setType] ~= "" then
            return true
        else
            self:Print(L["Gear necessary is missing from Protection " .. setType .. " settings"])
            return false
        end
    end

    if self.db.profile.Spec == "Fury" then
        if self.db.profile.FuryMH[setType] ~= "" and self.db.profile.FuryOH[setType] ~= "" and self.db.profile.FuryShield[setType] ~= "" then
            return true
        else
            self:Print(L["Gear necessary is missing from Fury " .. setType .. " settings"])
            return false
        end
    end

    if self.db.profile.Spec == "Arms" then
        if self.db.profile.Arms2H[setType] ~= "" and self.db.profile.Arms1H[setType] ~= "" and self.db.profile.ArmsShield[setType] ~= "" then
            return true
        else
            self:Print(L["Gear necessary is missing from Arms " .. setType .. " settings"])
            return false
        end
    end
end

function ShieldOn:CreateShieldSet(setType)
    --Prepare equipment manager
    self:IgnoreNonWeaponSlots()

    if self.db.profile.Spec == "Protection" then
        --Equip Shield set
        EquipItemByName(self.db.profile.Prot1H[setType], 16)
        EquipItemByName(self.db.profile.ProtShield[setType], 17)
    end

    if self.db.profile.Spec == "Fury" then
        -- Equip Shield set
        EquipItemByName(self.db.profile.FuryMH[setType], 16)
        EquipItemByName(self.db.profile.FuryShield[setType], 17)
    end

    if self.db.profile.Spec == "Arms" then
        --Equip Shield set
        EquipItemByName(self.db.profile.Arms1H[setType], 16)
        EquipItemByName(self.db.profile.ArmsShield[setType], 17)
    end

    --Save Shield Set, nil counts as False for normalSet parameter
    self:SaveSet(L[setType .. "Shield"], setType, nil)
end

function ShieldOn:CreateNormalSet(setType)
    --Assuming won't need a Protection Normal set
    --Prepare equipment manager
    self:IgnoreNonWeaponSlots()

    if self.db.profile.Spec == "Fury" then
        --Titan's Grip, Equip Normal set
        --EquipItemByName(self.db.profile.FuryMH[setType], 16) Main hand should already be equipped.
        EquipItemByName(self.db.profile.FuryOH[setType], 17)
    end

    if self.db.profile.Spec == "Arms" then
        --Equip Normal set
        EquipItemByName(self.db.profile.Arms2H[setType], 16)
    end

    --Save Normal set, 1 counts as True for normalSet parameter
    self:SaveSet(L[setType .. "Normal"], setType, 1)
end

function ShieldOn:IgnoreNonWeaponSlots()
    -- Reset slot ignore flags
    EquipmentManagerClearIgnoredSlotsForSave();
    --Ignore all armour slots
    for i = 1, 15 do
        EquipmentManagerIgnoreSlotForSave(i)
    end
    --Ignore tabard
    EquipmentManagerIgnoreSlotForSave(19)
end

function ShieldOn:SaveSet(info, setType, normalSet)
    --Confirmation provides the time delay needed to save both sets instead of them trying to complete at the same time
    StaticPopupDialogs["SAVE_SET" .. info] = {
        text = L["Do you want to save the set: "]..L[info].."?",
        button1 = L["Yes"],
        button2 = L["No"],
        OnAccept = function()
            SaveEquipmentSet(info, 1)
            if normalSet then
            	--When normalSet is true this is saving normal set
            	--This If is for when both PvE and PvP sets want setting up
				if setType == "PvE" and self.db.profile.PvPEnabled and self:CheckSet("PvP") then
            		self:CreateShieldSet("PvP")
            	end
            else
            	--When normalSet is not true this is saving shield set
            	self:CreateNormalSet(setType)
            end
        end,
        timeout = 10,
        whileDead = true,
        hideOnEscape = true,
        preferredIndex = 3,
    }
    StaticPopup_Show("SAVE_SET" .. info)
end